// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

abstract class IntSet {

// datenstrukturabhaengige, abstrakte Methoden:

    // liefert Enumeration ueber die Menge:
    public abstract IntEnumeration getEnumeration();

    // Einfuegen eines Elementes:
    public abstract void insert(int i);

    // Entfernen eines Elementes:
    public abstract void delete(int i);

// datenstrukturunabhaengige Methoden:

    // Abfrage, ob Menge leer ist:
    public boolean isEmpty() {
	return size() == 0;
    }

    // Abfrage, ob Element enthalten ist:
    public boolean contains(int i) {

// Testausgabe:
System.out.println("contains() aus IntSet");

	IntEnumeration enum = getEnumeration();

	while (enum.hasMoreElements()) {
	   int item = enum.nextElement();
	   // Falls gefunden:
	   if (item == i)
	      return true;
	}
	// i nicht gefunden:
	return false;
    }

    // Abfrage nach Groesse der Menge:
    public int size() {

// Testausgabe:
System.out.println("size() aus IntSet");

	int result = 0;
	IntEnumeration enum = getEnumeration();
	while (enum.hasMoreElements()) {
	   result++;
	   int dummy = enum.nextElement();
	}
	return result;
    }

    // Abfrage nach Teilmengeneigenschaft:
    public boolean isSubset(IntSet s) {

// Testausgabe:
System.out.println("isSubset() aus IntSet");

	IntEnumeration enum = getEnumeration();

	while (enum.hasMoreElements()) {

	    if (! s.contains(enum.nextElement()))
	       return false;
	}
	// Teilmengeneigenschaft ist nie verletzt:
	return true;
    }

    // Ausgabefunktion:
    public String toString() {
	String result = "{";
	IntEnumeration enum = getEnumeration();
	while (enum.hasMoreElements()) {
	   result += enum.nextElement();
	   if (enum.hasMoreElements())
	      result += ",";
	}
	return result + "}";
    }
}
