// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

abstract class OrderedIntSet extends IntSet {

// Methoden, die bei Sortiertheit effizienter implementierbar sind:

    // Abfrage, ob Element enthalten ist:
    public boolean contains(int i) {

// Testausgabe:
System.out.println("contains() aus OrderedIntSet");

	IntEnumeration enum = getEnumeration();

	while (enum.hasMoreElements()) {
	   int item = enum.nextElement();
	   // Falls gefunden:
	   if (item == i)
	      return true;
	   // Ordnung wird ausgenutzt:
	   if (item > i)
	      return false;
	}
	// i nicht gefunden:
	return false;
    }

    // Abfrage nach Teilmengeneigenschaft speziell bei sort. Eingabe:
    public boolean isSubset(OrderedIntSet s) {

// Testausgabe:
System.out.println("isSubset() fuer OrderedIntSet aus OrderedIntSet");

	     // Enumeration der Menge selbst:
	IntEnumeration enum = getEnumeration();
	     // Enumeration der anderen Menge:
	IntEnumeration enumS = s.getEnumeration();

	while (enum.hasMoreElements()) {
	    int item = enum.nextElement();

	    if (!enumS.hasMoreElements())
	       return false;

	    int itemS;

	    // groessere Elemente in s ueberspringen:
	    do {
	       itemS = enumS.nextElement();
	    } while (item > itemS && enumS.hasMoreElements());

	    if (item != itemS)
	        // Element der Menge kann nicht auch in s sein
		return false;
	}
	// Teilmengeneigenschaft ist nie verletzt:
	return true;
    }
}
