// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

class OrderedListIntSet extends OrderedIntSet {

// Attribute (Datenstruktur):

    private OrderedIntList list;	// speichert die Elemente der Menge

// Konstruktor fuer eine leere Menge:

    OrderedListIntSet() {
	list = null;
    }

// Konstruktor, der die Kopie einer Menge liefert:

    // Zuerst ein Konstruktur speziell fuer OrderedListIntSet:
    public OrderedListIntSet(OrderedListIntSet s) {

// Testausgabe:
System.out.println("CopyKonstr. fuer OrderedListIntSet aus OrderedListIntSet");

	list = OrderedIntList.copyList(s.list);
    }

    // Sonst muss sich der Konstruktur wenig effizient auf insertElement
    // abstuetzen:
    public OrderedListIntSet(IntSet s) {

// Testausgabe:
System.out.println("CopyKonstr. fuer beliebige Mengen aus OrderedListIntSet");

	list = null;
	IntEnumeration enum = s.getEnumeration();
	while (enum.hasMoreElements()) {
	   list = OrderedIntList.insertElement(enum.nextElement(), list);
	}
    }

// sonstige datenstrukturabhaengige Methoden:

    // effiziente Abfrage, ob Menge leer ist:
    public boolean isEmpty() {

// Testausgabe:
System.out.println("isEmpty() aus OrderedListIntSet");

	return list == null;
    }

    // liefert Enumeration ueber die Menge:
    public IntEnumeration getEnumeration() {
       return new OrderedListIntSetEnumeration(list);
    }

    // Einfuegen eines Elementes:
    public void insert(int i) {
        // sttzt sich auf entsprechende Methode von OrderedIntList:
	list = OrderedIntList.insertElement(i, list);
    }

    // Entfernen eines Elementes:
    public void delete(int i) {
        // sttzt sich auf entsprechende Methode von OrderedIntList:
	list = OrderedIntList.deleteElement(i, list);
    }
}
